
                                                 (*:  --Ŀ
                  [http://www.royale.linux-fan.com]ͻ 
                  ĿĿĿĿĿ  Ŀ  |
                .                Ŀ          
                :                   Ĵ  :
                    ٳ   Ŀ ٳ    Ŀ      .
                |           
                 [1999][royale@ifrance.com]ͼ
                --  :*)

(******************************** Royale PlatForm ****************************

fond.pcx     : Image 320*177*84  couleurs
sprites.pcx  : Image 320*200*168 couleurs dont la 1ere couleur est transparente
Les 4 couleurs restantes sont pour le fond noir et le texte...
Ecran : 304*176

*****************************************************************************)


program plat;
uses crt,sourunit,mode13,pcx;
type direction=(gauche,droite);
const scrn_pg=ptr($A000,0);
      xsize=30;    {hauteur du monsieur}
      ysize=47;    {largeur du monsieur}
      fondcol=253;
      textcol=254;
      whitcol=255;

var niv_ptr,temp_pg,sprt_pg:pointer;   {pointeurs de pages virtuelles.}
    xe,ye,xs,ys,i,j:word;
    curseur:byte;
    cur:word;
    fic:file;
    s,filename:string;

    header:record
      name:string[26];
      xmax,ymax:word;
      fond,sprites:string[12];
      X_scroll,Y_scroll:boolean;
      run_spe,climb_spe,rol_acc,run_acc,gravity,inertie,reb_sol,reb_pfd,reb_mur,reb_jmp,x_anticip,y_anticip:real;
      xdeb,ydeb:word;
    end;

procedure init_tout;
begin
  header.xmax:=50;
  header.ymax:=50;
  getmem(niv_ptr,$FFFF);
  getmem(temp_pg,320*200);
  getmem(sprt_pg,320*200);
  init_mode13;
  loadpcx('pix\sprites.pcx',sprt_pg,0,168-1);
  pal[0]:=0;
  pal[1]:=0;
  pal[2]:=0;
  pal[759]:=0;
  pal[760]:=0;
  pal[761]:=0;
  pal[762]:=250;
  pal[763]:=100;
  pal[764]:=100;
  pal[765]:=255;
  pal[766]:=255;
  pal[767]:=75;
  setpal;
end;

procedure close_tout;
begin
  freemem(niv_ptr,$FFFF);
  freemem(temp_pg,320*200);
  freemem(sprt_pg,320*200);
  close_mode13;
end;

function niv(i,j:word):byte;
begin
  niv:=mem[seg(niv_ptr^):j*header.xmax+i];
end;

procedure show_mouse;
const t=textcol;
      w=whitcol;
      souris:array [0..9,0..9] of byte=
                ((t,t,t,t,t,t,t,0,0,0),
                 (t,w,w,w,t,0,0,0,0,0),
                 (t,w,w,t,0,0,0,0,0,0),
                 (t,w,t,w,t,0,0,0,0,0),
                 (t,t,0,t,w,t,0,0,0,0),
                 (t,0,0,0,t,w,t,0,0,0),
                 (t,0,0,0,0,t,w,t,0,0),
                 (0,0,0,0,0,0,t,w,t,0),
                 (0,0,0,0,0,0,0,t,w,t),
                 (0,0,0,0,0,0,0,0,t,t));
begin
  xs:=x_souris div 2;
  ys:=y_souris;
  for i:=0 to 9 do for j:=0 to 9 do
    if (souris[i,j]<>0) and (ys+j<192) and (xs+i<320) then
    mem[seg(temp_pg^):(ys+j)*320+(xs+i)]:=souris[i,j];
end;

procedure make_screen;
begin
  clearpage(temp_pg);
  for i:=0 to 19 do for j:=0 to 11 do
    copyblock(16,16,sprt_pg,niv(i+xe,j+ye) mod 20*16,
    niv(i+xe,j+ye) div 20*16,temp_pg,i*16,j*16,true,false);
end;


begin
  init_tout;
  init_souris;
  sens_souris(100,100);
  fillchar(niv_ptr^,64000,0);
  fillchar(temp_pg^,64000,fondcol); {pour voir les bordures !}
  souris_en_xy(320,100);
  repeat
    if xs>=319 then begin
      if xe<header.xmax-20 then inc(xe);
      souris_en_xy(318*2,ys);
    end;
    if xs<=0 then begin
      if xe>0 then dec(xe);
      souris_en_xy(2,ys);
    end;
    if ys>=192 then begin
      if ye<header.ymax-12 then inc(ye);
      souris_en_xy(xs*2,191);
    end;
    if ys<=0 then begin
      if ye>0 then dec(ye);
      souris_en_xy(xs*2,1);
    end;
    if souris_bout=1 then
      if cur<256 then mem[seg(niv_ptr^):(ye+ys div 16)*header.xmax+xe+xs div 16]:=cur
      else begin
        header.xdeb:=xe*16+xs;
        header.ydeb:=ye*16+ys;
      end;
    if souris_bout=2 then cur:=mem[seg(niv_ptr^):(ye+ys div 16)*header.xmax+xe+xs div 16];

    if port[$60]=2 then
      for i:=0 to 7 do for j:=0 to 6 do
        if ((j<>0) or (i<>0) and (i<>7))
       and ((j<>5) or (i<6))
       and ((j<>6) or (i=3))
      then mem[seg(niv_ptr^):(j+ye+ys div 16)*header.xmax+i+xe+xs div 16]:=j*20+i;

    if port[$60]=3 then
      for i:=0 to 7 do for j:=0 to 4 do
        mem[seg(niv_ptr^):(j+ye+ys div 16)*header.xmax+i+xe+xs div 16]:=52+j*20+i;

    if port[$60]=4 then
      for i:=0 to 1 do for j:=0 to 3 do
        mem[seg(niv_ptr^):(j+ye+ys div 16)*header.xmax+i+xe+xs div 16]:=70+j*20+i;

    if port[$60]=48 then begin
      repeat
        copypage(sprt_pg,temp_pg);
        show_mouse;
        copypage(temp_pg,scrn_pg);
        if souris_bout=1 then
          cur:=(ys div 16)*20+xs div 16;
          if ys>112 then cur:=256;
          if ys>160 then cur:=257;
      until (souris_bout<>0);
      repeat until souris_bout=0;
    end;
    if port[$60]=59 then begin
      close_mode13;
      while keypressed do readkey;
      write('Xmax = '); readln(header.xmax);
      write('Ymax = '); readln(header.ymax);
      fillchar(niv_ptr^,64000,0);
      init_mode13;
      setpal;
    end;
    if port[$60]=60 then begin
      close_mode13;
      while keypressed do readkey;
      write('Sauver Fichier ? '); readln(filename);
      writeln('Sauvegarde...');
      assign(fic,'levels\'+filename);
      rewrite(fic,1);
      if ioresult=0 then begin
        blockwrite(fic,header,sizeof(header));
        blockwrite(fic,niv_ptr^,header.xmax*header.ymax);
        close(fic);
      end;
      init_mode13;
      setpal;
    end;
    if port[$60]=61 then begin
      close_mode13;
      while keypressed do readkey;
      write('Ouvrir Fichier ? '); readln(filename);
      writeln('Ouverture...');
      assign(fic,'levels\'+filename);
      reset(fic,1);
      blockread(fic,header,sizeof(header));
      blockread(fic,niv_ptr^,header.xmax*header.ymax);
      close(fic);
      init_mode13;
      setpal;
    end;
    if port[$60]=62 then with header do begin
      close_mode13;
      writeln('Modification des variables...');
      writeln;
      writeln('  NOM      : ',name);
      writeln('  Fond     : ',fond);
      writeln('  X_scroll : ',X_scroll);
      writeln('  Y_scroll : ',Y_scroll);
      writeln('  Sprites  : ',sprites);
      writeln('  run_spe  = ',run_spe:2:2);
      writeln('  climb_sp = ',climb_spe:2:2);
      writeln('  rol_acc  = ',rol_acc:2:2);
      writeln('  run_acc  = ',run_acc:2:2);
      writeln('  gravity  = ',gravity:2:2);
      writeln('  inertie  = ',inertie:2:2);
      writeln('  reb_sol  = ',reb_sol:2:2);
      writeln('  reb_pfd  = ',reb_pfd:2:2);
      writeln('  reb_mur  = ',reb_mur:2:2);
      writeln('  reb_jmp  = ',reb_jmp:2:2);
      writeln('  x_antici = ',x_anticip:2:2);
      writeln('  y_antici = ',y_anticip:2:2);
      repeat
        gotoxy(14,curseur+3);
        if port[$60]=72 then if curseur=0 then curseur:=16 else dec(curseur);
        if port[$60]=80 then if curseur=16 then curseur:=0 else inc(curseur);
        if port[$60]=28 then begin
          clreol;
          while keypressed do readkey;
          case curseur of
            0:readln(name);
            1:readln(fond);
            2:begin readln(s); if s='true' then X_scroll:=true else X_scroll:=false; end;
            3:begin readln(s); if s='true' then Y_scroll:=true else Y_scroll:=false; end;
            4:readln(sprites);
            5:readln(run_spe);
            6:readln(climb_spe);
            7:readln(rol_acc);
            8:readln(run_acc);
            9:readln(gravity);
           10:readln(inertie);
           11:readln(reb_sol);
           12:readln(reb_pfd);
           13:readln(reb_mur);
           14:readln(reb_jmp);
           15:readln(x_anticip);
           16:readln(y_anticip);
          end;
        end;
        repeat until not (port[$60] in [72,80,28]);
        while keypressed do readkey;
      until port[$60]=1;
      repeat until port[$60]<>1;
      init_mode13;
      setpal;
    end;
    while keypressed do readkey;
    make_screen;
    if (header.xdeb>=xe*16) and (header.xdeb<=(xe+19)*16-xsize)
    and (header.ydeb>=ye*16) and (header.ydeb<=(ye+11)*16-ysize) then
      copyblock(xsize,ysize,sprt_pg,0,113,temp_pg,header.xdeb-xe*16,header.ydeb-ye*16,false,false);
    show_mouse;
    copypage(temp_pg,scrn_pg);
  until port[$60]=1;
  close_tout;
end.